<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

class modCommerceBestsellersHelper
{
	function getItems($params, $section_id)
	{
		$db	=& JFactory::getDBO();
		$user = JFactory::getUser();

		$sql = "SELECT r.title, r.id,  rc.catid, u.username, u.name, r.user_id, r.type_id, COUNT(op.product_id) as total
		FROM #__js_res_record AS r
		JOIN #__js_res_record_category rc ON rc.record_id = r.id
		JOIN #__users u ON u.id = r.user_id
		JOIN #__jc_orders_products op ON op.product_id = r.id		
		WHERE(r.extime > NOW() OR r.extime = '0000-00-00 00:00:00') AND r.ctime < NOW() AND r.published = '1'
		AND r.access <= ".$user->aid."
		AND op.section_id = '$section_id'
		GROUP BY op.product_id
		ORDER BY total DESC
		LIMIT 0, ".$params->get('max_items', 2);
		$db->setQuery($sql);
		$list = $db->loadObjectList();

		foreach ($list as $i => $val)
		{
			if($params->get('show_picture'))
			$list[$i]->picture = modCommerceBestsellersHelper::getFieldInfo($val->id, $val->type_id, 'picture', $user);
			if($params->get('show_price'))
			$list[$i]->price = modCommerceBestsellersHelper::getFieldInfo($val->id, $val->type_id, 'price', $user);
			if($params->get('show_addtocart'))
			$list[$i]->addtocart = modCommerceBestsellersHelper::getFieldInfo($val->id, $val->type_id, 'addtocart', $user);
		}
		return $list;
	}

	function getFieldInfo($record_id, $type_id, $field, $user)
	{
		$db	=& JFactory::getDBO();
		$sql = "SELECT v.id, v.record_id, f.id as fid, v.field_value, v.params as vparams, f.filter,
		f.params, f.title, f.type, f.ordering
		FROM #__js_res_record_values as v
		LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id
		WHERE v.record_id = '". $record_id ."'
		AND f.type = '$field' AND f.access <= ".$user->get( 'aid', 0 )
		." AND f.published = 1
		ORDER BY f.ordering ASC ";

		$db->setQuery($sql);
		$field = $db->loadObject();
		return $field;
	}

}
